 list       F=inhx8m, P=12F615, R=hex, N=0
#include  P12F615.inc; PIC definitions
 __config _BOR_ON & _IOSCFS_8MHZ & _CP_OFF & _MCLRE_OFF & _PWRTE_OFF & _WDT_OFF & _INTOSCIO
 Errorlevel -302      ; switches off Message [302]: Register in operand not in bank 0.
#define ZeroCross porta,2
#define Trigger porta,5
	cblock 0x40
		WaitCounter,WaitCounter2
		TriggerDelay
	endc

GLMinVal		=       d'140'
GLMaxVal		=		d'2'

                org     0
                goto    Init
                org     4
				btfsc intcon,intf
				goto Int_From_ZeroCross
				goto Mainloop
Int_From_ZeroCross
				clrf tmr0
				movf TriggerDelay,w
				btfss zero
				bcf Trigger
				bcf intcon,intf
				bsf intcon,gie
				goto Mainloop
Init          
				bank1
                movlw b'11111000'
                movwf option_reg             
                clrf ansel
                Bank0
                clrf intcon
				clrf ccp1con
				clrf t1con
				bank1
				clrf PIE1
				clrf ANSEL
				bank0
				clrf adcon0
				clrf INTCON
Start
				bank1
				movlw b'11011111'
				movwf TRISA
				bsf option_reg,intedg
				bcf option_reg,t0cs
				bcf option_reg,PSA
				bsf option_reg,ps2
				bsf option_reg,ps1
				bcf option_reg,ps0
				bank0
				bcf Trigger
				call wait250msec
				call wait250msec
				clrf intcon
				bsf intcon,inte
				bcf intcon,intf
				bsf intcon,gie
				MOVLW b'00001101'
				movwf adcon0
				BANK1
				bsf ansel,3
				bank0
				bsf adcon0,1
				btfsc adcon0,1
				goto $-1
				movlw GLMinVal
				subwf ADRESH,W
				movlw 0xff
				btfss carry
			 	MOVF ADRESH,W
				movwf TriggerDelay
Mainloop
				btfsc adcon0,1
				goto Cont1
				movlw GLMinVal
				subwf ADRESH,W
				movlw 0xff
				btfsc carry
				goto LoadNewVal
				movlw GLMaxVal
				subwf ADRESH,W
				movlw 0x00
				btfss carry
				goto LoadNewVal
			 	MOVF ADRESH,W
LoadNewVal
				movwf TriggerDelay
				bsf adcon0,1
Cont1
				movf tmr0,w
				subwf TriggerDelay,w
				btfsS carry
				bsf Trigger
				goto MainLoop
				goto MainLoop

StartDelayCount movwf WaitCounter2		;1    
BackWaitLoop2
				movlw d'164'			;1
                call WaitWx4Cycles
				movlw d'164'			;1
                call WaitWx4Cycles
			;	movlw d'164'			;1
             ;   call WaitWx4Cycles
			;	movlw d'164'			;1
             ;   call WaitWx4Cycles
				nop
				nop
                decf WaitCounter2,f		;1
                btfss zero				;1
                goto BackWaitLoop2		;2
                return					;2

WaitWx4Cycles   movwf WaitCounter
BackWaitLoop    decfsz WaitCounter,f
                goto BackWaitLoop
                return

Wait1mSec       movlw d'1'
                goto StartDelayCount
Wait2mSec       movlw d'2'
                goto StartDelayCount
Wait4mSec       movlw d'4'
                goto StartDelayCount
Wait10mSec      movlw d'10'
                goto StartDelayCount
Wait100mSec      movlw d'100'
                goto StartDelayCount
Wait250mSec     movlw d'250'
                goto StartDelayCount


Wait1Sec		call Wait250mSec
				call Wait250mSec
				call Wait250mSec
				goto Wait250mSec



Fins
                end 
